#include <Xm/CascadeB.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>

#include "xtc_rsrc.h"
#include "xtc_menu.h"

#include <malloc.h>
#include <stdio.h>



static void
InitializeItemArray (Menu menu)
{
  menu->items = (Widget*)malloc(10*sizeof(Widget));
  menu->cur_item_array_size = 10;
}


static void
AppendToItemArray (Menu menu, Widget newitem)
{
  menu->items[menu->cur_child_count] = newitem;
  if (++(menu->cur_child_count) == menu->cur_item_array_size) {
    menu->cur_item_array_size += 10;
    menu->items = 
      (Widget*) realloc(menu->items, menu->cur_item_array_size*sizeof(Widget));
  }
}

   

Menu
XTCmenu_openPulldown (Widget parent, char *name)
{
   Menu nnew;

   nnew = (Menu)malloc(sizeof(MenuRec));
   nnew->manager = XmCreatePulldownMenu (parent, name, NULL, 0);
   nnew->cur_child_count = 0;
   
   InitializeItemArray (nnew);
   
   nnew->name = malloc(strlen(name)+1);
   strcpy (nnew->name, name);
   
   START_ARGS;
   ARG(XmNsubMenuId,nnew->manager);
   nnew->cascade = XmCreateCascadeButton (parent, name, args, args_count);
   XtManageChild (nnew->cascade);

   return nnew;
}

  

Menu
XTCmenu_openSubmenu (Menu parentmenu, char *name)
{
  Menu submenu = XTCmenu_openPulldown (parentmenu->manager, name);
  AppendToItemArray (parentmenu, submenu->cascade);
  return submenu;
}
  

void
XTCmenu_addItems (Menu menu, int count, void (*callback)())
{
  char button_name[500];
  Widget pb;

  while (count--) {
    sprintf (button_name, "MENU_%s_%d", menu->name, menu->cur_child_count);
    pb = XmCreatePushButton (menu->manager, button_name, NULL, 0);
    XtManageChild (pb);
    XtAddCallback (pb, XmNactivateCallback, 
		   (XtCallbackProc)callback, (caddr_t)menu->cur_child_count);
    AppendToItemArray (menu, pb);
  }
}


void
XTCmenu_close (Menu menu)
{
  if (menu);   /* just to keep away compiler warnings */
}


void
XTCmenu_setItemSensitivity (Menu menu, int index, Boolean status)
{
  XtSetSensitive (menu->items[index], status);
}


void
XTCmenu_setAllItemsSensitivity (Menu menu, Boolean status)
{
  register int i;
  for (i=0; i<menu->cur_child_count; i++)
    XTCmenu_setItemSensitivity (menu, i, status);
}
